/*
 * linux/arch/arm/drivers/sound/v_drv_sam.S
 *
 * Copyright (C) 1994, 1995, 1996 Russell King
 *
 * Voice low level filler.
 *
 * Takes data out of the voice buffer, translates it,
 * and puts it in the output buffer.
 */

		.text

		.global	_voice_driver_fill
#define REST(loopname, len) \
		subs	r4, r4, r8, lsl $1	;\
		movmi	r4, $0			;\
		strb	r4, [r0], r2		;\
		add	r7, r7, $len		;\
		bic	r7, r7, r10		;\
		subs	r6, r6, $len		;\
		beq	_fill			;\
		cmp	r0, r1			;\
		blt	loopname

@ r0	=	start
@ r1	=	end
@ r2	=	inc
@ r3	=	ptr to private data
@   +4	=	pointer to voice_driver info

_voice_driver_fill:
		LDR	r3,[r3,#12]
		LDMIA	r3,{r5-r11}
		RSB	r8,r8,#127
@ r5	=	wr_buf
@ r6	=	wr_cnt
@ r7	=	wr_tail
@ r8	=	volume
@ r9	=	conversion table
@ r10	=	size
		TEQ	r6,#0
		BEQ	_fill1
		TEQ	r9,#0
		BEQ	_loopnone
		TEQ	r11,#16
		BEQ	_loop16S
		TEQ	r11,#17
		BEQ	_loop16U
		TEQ	r11,#8
		BEQ	_loop8S
		TEQ	r11,#9
		BEQ	_loop8U
@ Log filler
_looplog:	LDRB	r4,[r5,r7]
		LDRB	r4,[r9,r4]
		REST(_looplog, 1)
		B	_endlp
@ Vidc log filler (faster than log filler, and no volume)
_loopnone:	LDRB	r4,[r5,r7]
		REST(_loopnone, 1)
		B	_endlp
@ Signed 16-bit filler
_loop16S:	LDR	r4,[r5,r7]
		MOV	r4,r4, lsl #16
		LDRB	r4,[r9,r4, lsr #19]
		REST(_loop16S, 2)
		B	_endlp
@ Signed 8-bit filler
_loop8S:	LDRB	r4,[r5,r7]
		LDRB	r4,[r9,r4, lsl #5]
		REST(_loop8S, 1)
		B	_endlp
@ Unsigned 16-bit filler
_loop16U:	LDR	r4, [r5, r7]
		MOV	r4, r4, lsl #16
		EOR	r4, r4, #0x80000000
		LDRB	r4, [r9, r4, lsr #19]
		REST(_loop16U, 2)
		B	_endlp
@ Unsigned 8-bit filler
_loop8U:	LDRB	r4,[r5,r7]
		EOR	r4,r4,#0x80
		LDRB	r4,[r9,r4, lsl #5]
		REST(_loop8U, 1)

_endlp:		STMIA	r3,{r5-r7}
		MOV	r7,r10, lsr #2
		ADD	r7,r7,r10, lsr #1
		CMP	r6,r7
		MOVGTS	pc,lr
		ADD	r0,r3,#28
		B	_wake_up_interruptible

_fill:		CMP	r0,r1
		BGE	_end
_fill1:		MOV	r4,#0
_fill2:		STRB	r4,[r0],r2
		CMP	r0,r1
		BLT	_fill2
_end:		STMIA	r3,{r5-r7}
		ADD	r0,r3,#28
		B	_wake_up_interruptible
