/*
 * linux/arch/arm/drivers/sound/v_drv_wave.s
 *
 * Copyright (C) 1994, 1995, 1996 Russell King
 *
 * Voice low level filler - 256 byte wave table version.
 *
 * Uses a phase accumulator and a wave table.
 */

		.text
		.global	_voice_driver_wave

@ r0	=	start
@ r1	=	end
@ r2	=	inc
@ r3	=	ptr to private data
@   +4	=	pointer to voice_driver info

_voice_driver_wave:
		LDR	r10,[r3,#12]
		LDMIA	r10,{r5-r9}
		RSB	r8,r8,#127
@ r5	=	
@ r6	=	duration
@ r7	=	phase accumulator
@ r8	=	volume
@ r9	=	wave table
@ r10	=	
@ r11	=	
_loop:		LDRB	r4,[r9,r7, lsr #24]
		ADD	r7,r7,r7, lsl #16
		SUBS	r4,r4,r8, lsl #1
		MOVMI	r4,#0
		STRB	r4,[r0],r2
		SUBS	r6,r6,#1
		MOVMI	r6,#0
		LDRB	r4,[r9,r7, lsr #24]
		ADD	r7,r7,r7, lsl #16
		SUBS	r4,r4,r8, lsl #1
		MOVMI	r4,#0
		STRB	r4,[r0],r2
		SUBS	r6,r6,#1
		MOVMI	r6,#0
		LDRB	r4,[r9,r7, lsr #24]
		ADD	r7,r7,r7, lsl #16
		SUBS	r4,r4,r8, lsl #1
		MOVMI	r4,#0
		STRB	r4,[r0],r2
		SUBS	r6,r6,#1
		MOVMI	r6,#0
		LDRB	r4,[r9,r7, lsr #24]
		ADD	r7,r7,r7, lsl #16
		SUBS	r4,r4,r8, lsl #1
		MOVMI	r4,#0
		STRB	r4,[r0],r2
		SUBS	r6,r6,#1
		MOVMI	r6,#0
		CMP	r0,r1
		BLT	_loop
		STMIA	r10,{r5-r7}
		TEQ	r6,#0
		MOVNES	pc,lr
		MOV	r0,r3
		LDR	pc,[r3,#8]		@ call gate off
