/*
 * include/asm-arm/arch-ebsa285/irq.h
 *
 * Copyright (C) 1996 Russell King
 */

#define IRQ_CLEAR       ((volatile unsigned int *)(DC21285_ARMCSR_BASE + IRQ_ENABLE_CLEAR))
#define IRQ_SET         ((volatile unsigned int *)(DC21285_ARMCSR_BASE + IRQ_ENABLE_SET))
#define IRQ_SHOW        ((volatile unsigned int *)(DC21285_ARMCSR_BASE + IRQ_ENABLE))
 
#define BUILD_IRQ(s,n,m)

extern void IRQ_interrupt(void);
extern void timer_IRQ_interrupt(void);
extern void fast_IRQ_interrupt(void);
extern void bad_IRQ_interrupt(void);
extern void probe_IRQ_interrupt(void);

#define IRQ_interrupt0 IRQ_interrupt
#define IRQ_interrupt1 IRQ_interrupt
#define IRQ_interrupt2 IRQ_interrupt
#define IRQ_interrupt3 IRQ_interrupt
#define IRQ_interrupt4 IRQ_interrupt
#define IRQ_interrupt5 IRQ_interrupt
#define IRQ_interrupt6 timer_IRQ_interrupt
#define IRQ_interrupt7 IRQ_interrupt
#define IRQ_interrupt8 IRQ_interrupt
#define IRQ_interrupt9 IRQ_interrupt
#define IRQ_interrupt10 IRQ_interrupt
#define IRQ_interrupt11 IRQ_interrupt
#define IRQ_interrupt12 IRQ_interrupt
#define IRQ_interrupt13 IRQ_interrupt
#define IRQ_interrupt14 IRQ_interrupt
#define IRQ_interrupt15 IRQ_interrupt

#define IRQ_INTERRUPT(n)	IRQ_interrupt##n
#define FAST_INTERRUPT(n)	fast_IRQ_interrupt
#define BAD_INTERRUPT(n)	bad_IRQ_interrupt
#define PROBE_INTERRUPT(n)	probe_IRQ_interrupt

static __inline__ void mask_irq(unsigned int irq)
{
        
        *IRQ_CLEAR = (1 << irq) ;
}

static __inline__ void unmask_irq(unsigned int irq)
{
        *IRQ_SET = (1 << irq) ;
}
 
static __inline__ unsigned long get_enabled_irqs(void)
{
	return *IRQ_SHOW ;
}

static __inline__ void irq_init_irq(void)
{
	unsigned long flags;

	save_flags (flags);
	cli ();
	*IRQ_CLEAR = 0xffffffff ;      /* clear all interrupt enables */
	restore_flags (flags);
}
